"use strict";
this.name        = "Escort_Contracts"; 
this.author      = "capt murphy"; 
this.copyright   = "2011 capt murphy";
this.licence     = "CC BY-NC-SA 3.0"; // see http://creativecommons.org/licenses/by-nc-sa/3.0/ for more info.
this.description = "Allows players to enter into short term escort contracts with NPC traders."; 
this.version     = "1.5.6";


this.startUp = function()
{
	if (!missionVariables.ec_escortrep) // first run of oxp - ec_escortrep should be only persistent variable between save games unless game is saved just after a contract is accepted.
		{this.ec_escortrep = 0;}
	else {this.ec_escortrep = missionVariables.ec_escortrep;} // otherwise load value from save game.
	if (missionVariables.ec_currentcontract && missionVariables.ec_currentcontract !== "no") // values might be "no" or "YES" if upgrading from previous version of oxp otherwise will be true, "success", or null/false.
        {
		    if (missionVariables.ec_currentcontract === "success") // might happen if mother safely enters Aegis, and then player docks at OXP station and uses Save Anywhere.
			{this.ec_currentcontract = "success";}
			else {this.ec_currentcontract = true;} // if true or "success" load other contract details from save file.
			this.ec_contractactualprice = missionVariables.ec_contractactualprice;
			this.ec_contractexpiretime = missionVariables.ec_contractexpiretime;
			this.ec_killsbonus = missionVariables.ec_killsbonus;
			this.ec_missionkills = missionVariables.ec_missionkills;
			this.ec_mothername = missionVariables.ec_mothername;
			this.ec_targetsystem = missionVariables.ec_targetsystem;
		}
	else {this.ec_currentcontract = false; delete missionVariables.ec_currentcontract;} // otherwise no current contract.
	// clean up superflous missionVariables from previous versions of OXP.
	delete missionVariables.ec_contractdifficultydesc;
    delete missionVariables.ec_contractdifficultystars;
	delete missionVariables.ec_escortrepstring;
	delete missionVariables.ec_motherfrustration;
	delete missionVariables.ec_numbertargetsystems;
	delete missionVariables.ec_payment;
	delete missionVariables.ec_targetsystem;
	delete missionVariables.ec_targetsystemgovernmentname;
	delete missionVariables.ec_targetsystemname;
	delete missionVariables.ec_contractactualprice;
	delete missionVariables.ec_contractexpiretime;
	delete missionVariables.ec_killsbonus;
	delete missionVariables.ec_missionkills;
	delete missionVariables.ec_mothername;
	delete missionVariables.ec_targetgovsymbol;
	delete missionVariables.ec_currentsystemeco;
	delete missionVariables.ec_targetecosymbol;
	delete missionVariables.ec_currentsystemname;
	delete missionVariables.ec_currentsystemgov;
	delete missionVariables.ec_currentsystemtech;
	delete missionVariables.ec_currentsystemeco;
	delete missionVariables.ec_targettech;
	 {this.ec_runcontractsetup = true;}
 	this.$EscortF4Interface();
}

this.playerWillSaveGame = function()
{
  missionVariables.ec_escortrep = this.ec_escortrep; // always save current reputation
  if (this.ec_currentcontract) // only save other contract essential missionVariables if game is saved whilst there is a current contract.
  {
	missionVariables.ec_currentcontract = this.ec_currentcontract;
	missionVariables.ec_contractactualprice = this.ec_contractactualprice; 
	missionVariables.ec_contractexpiretime = this.ec_contractexpiretime;
	missionVariables.ec_killsbonus = this.ec_killsbonus;
	missionVariables.ec_missionkills = this.ec_missionkills;
	missionVariables.ec_mothername = this.ec_mothername;
	missionVariables.ec_targetsystem = this.ec_targetsystem;
  }
  else {delete missionVariables.ec_currentcontract;}
}
	
   
// event handler driven function checking conditions for showing contract success mission screen or new contract offer screens. Also defines contract failure if a player docks part way through a contract.
this.shipDockedWithStation = function()
{
  delete this.ec_leftScreen; // reset this flag if present.
  if (!this.ec_currentcontract && player.ship.equipmentStatus("EQ_FRAME_SAVE") !== "EQUIPMENT_OK") // if no current contract and dock is not part of Save Anywhere Process then set flag for contract setup.
  {this.ec_runcontractsetup = true;}
  else if (this.ec_currentcontract === "success" && system.info.systemID === this.ec_targetsystem && player.ship.dockedStation.isMainStation && player.ship.equipmentStatus("EQ_FRAME_SAVE") !== "EQUIPMENT_OK") // if docking after successful contract then process award payment etc, unless dock is part of Save Anywhere process.
  {
    this.ec_payment = this.ec_contractactualprice + (this.ec_missionkills * this.ec_killsbonus);
	player.credits += this.ec_payment;
	this.ec_escortrep++;
	if (this.ec_escortrep > 20)
			{this.ec_escortrep = 20;}
	mission.setInstructionsKey (null, "Escort_Contracts");
	delete this.ec_currentcontract;
	this.ec_runcontractsuccess = true;
	if (this.mother && this.mother.isValid) {this.mother.remove(true);}
  }
  else if (this.ec_currentcontract && this.ec_currentcontract !== "success") // docking anywhere whilst contract is ongoing fails contract unless currentcontract is already a "success".
  {
    if (system.info.systemID === this.ec_targetsystem)
	{
		delete this.ec_currentcontract;
		mission.setInstructionsKey (null, "Escort_Contracts");
		this.ec_escortrep -= 2;
		if (this.ec_escortrep < -10)
		{this.ec_escortrep = -10;}
		player.consoleMessage("Escort Contract: You have docked before your mother is safe. Contract Terminated.",10);
		if (this.mother && this.mother.isValid) {this.mother.remove(true);}
	}
	else 
	{
	if (this.mother && this.mother.isValid) {this.mother.remove(true);}
	this.ec_failedtofollowmother();
	}
  }
  	this.$EscortF4Interface();
}
// sets up appropriate mission screens for either contract success or new contract offers.
this.missionScreenOpportunity = function()
{
	if (player.ship.docked && player.ship.dockedStation.isMainStation && this.ec_runcontractsuccess) // show screens for contract success if appropriate flag is set.
	{
		delete this.ec_runcontractsuccess;
		this.ec_runcontractsetup = true; // chance of another contract being offered after mission screen has ended.
		missionVariables.ec_mothername = this.ec_mothername;
		missionVariables.ec_targetsystemname = system.name;
		missionVariables.ec_payment = this.ec_payment;
		missionVariables.ec_missionkills = this.ec_missionkills;
		if (missionVariables.ec_missionkills === 0)
			{
			mission.runScreen ({title: "ITHA Escort Contract Success", messageKey: "contract_success_nokill", background :"escort_contracts_bkg2.png"});
			}
		if (missionVariables.ec_missionkills === 1)
			{
			mission.runScreen ({title: "ITHA Escort Contract Success", messageKey: "contract_success_onekill", background :"escort_contracts_bkg2b.png"});
			}
		if (missionVariables.ec_missionkills > 1)
			{
			mission.runScreen ({title: "ITHA Escort Contract Success", messageKey: "contract_success", background :"escort_contracts_bkg2c.png"});
			}
		delete missionVariables.ec_mothername;
		delete missionVariables.ec_targetsystem;
		delete missionVariables.ec_payment;
		delete missionVariables.ec_missionkills;
		delete missionVariables.ec_targetsystemname;
	}
	else if (this.ec_runcontractsetup)
	{delete this.ec_runcontractsetup;}
}
//  the following functions control the offering and display of the available new contracts on mission screens.		
//  sets up arrays containing the info needed for potential contracts

//Trying to get F4 screen to work.

this.$EscortF4Interface = function(station) {
	if (player.ship.docked && player.ship.dockedStation.isMainStation && player.ship.equipmentStatus("EQ_ESCORTCONTRACTS") === "EQUIPMENT_OK" && this.ec_runcontractsetup && player.bounty === 0 && Math.random() < (0.4*(1+(this.ec_escortrep / 20)))) // various validity checks including random factor modified by escortrep to see if contracts will be offered.
	{ {  
	var systemsInRange = SystemInfo.systemsInRange(7); // array of systemInfos within 7 light years
	var systemsInRangeID = new Array(); // array to hold ID's only of systems in range
	this.ec_targetsystems = new Array(); // array to hold sunset of possible contract destinations.
	var counter = 0;
	for (counter = 0; counter < systemsInRange.length;counter++) //populate systemsInRangeID
	{systemsInRangeID[counter] = systemsInRange[counter].systemID;}
	counter = 0;
	var tempcounter = 0;
	var thisGalaxy = system.info.galaxyID;
	var currentGovernement = system.government;
	for (counter = 0; counter < systemsInRangeID.length;counter++) // populate ec_targetsystems.
	{
		if (System.infoForSystem(thisGalaxy,systemsInRangeID[counter]).government < currentGovernement && Math.random()<0.5 && !System.infoForSystem(thisGalaxy,systemsInRangeID[counter]).sun_gone_nova)
		{
			this.ec_targetsystems[tempcounter] = systemsInRangeID[counter];
			tempcounter++;
		}
		
	}
	// create and populate other arrays to hold contract info for each potential target system
	missionVariables.ec_numbertargetsystems = this.ec_targetsystems.length;
	this.ec_targetsystemsgovernment = new Array(this.ec_targetsystems.length);
	this.ec_targetsystemseco = new Array(this.ec_targetsystems.length);
	this.ec_targetsystemstech = new Array(this.ec_targetsystems.length);
	this.ec_targetsystemsnames = new Array(this.ec_targetsystems.length);
	this.ec_mothernames = new Array(this.ec_targetsystems.length);
	this.ec_contractbaseprice = new Array(this.ec_targetsystems.length);
	this.ec_contractactualprice = new Array(this.ec_targetsystems.length);
	this.ec_killsbonus = new Array(this.ec_targetsystems.length);
	counter = 0;
	for (counter =0;counter < this.ec_targetsystems.length;counter++)
	{
		this.ec_targetsystemsgovernment[counter] = System.infoForSystem(thisGalaxy, this.ec_targetsystems[counter]).government;
		this.ec_targetsystemseco[counter] = System.infoForSystem(thisGalaxy, this.ec_targetsystems[counter]).economy;
		this.ec_targetsystemstech[counter] = System.infoForSystem(thisGalaxy, this.ec_targetsystems[counter]).techlevel;
		this.ec_targetsystemsnames[counter] = System.infoForSystem(thisGalaxy, this.ec_targetsystems[counter]).name;
		this.ec_mothernames[counter] = randomName();
		this.ec_contractbaseprice[counter] = (75 + (75 * (7 - this.ec_targetsystemsgovernment[counter])));
		this.ec_contractactualprice[counter] = Math.round(this.ec_contractbaseprice[counter] * (0.51 + Math.random() + (this.ec_escortrep / 20)));
		this.ec_killsbonus[counter] = Math.round(40 * (0.51 + Math.random() + (this.ec_escortrep / 20)));
	}
		
}
	
	
	{
	player.ship.dockedStation.setInterface("escort_f4contracts",{
			title: "ITHA Escort Contracts (" +missionVariables.ec_numbertargetsystems+" available)",
			category: "Escort Jobs",
			summary: "Independent Traders & Hauliers Association pilots will pay you to escort them through a nearby system. You must launch within 3 hours of accepting a contract.",
			callback: this.ec_displaymissionScreens.bind(this)
			}
		);
	}}
	else {
		player.ship.dockedStation.setInterface("escort_f4contracts",null);//remove interface if contract accepted or no offers
	}
}

// shows initial mission screen advising that contracts are available
this.ec_displaymissionScreens = function()
{
	if(missionVariables.ec_numbertargetsystems === 1)
	{	
		this.ec_contractno = 0;
		this.ec_updatemissionvariables();
		mission.runScreen({title: "Escort Contract: Trader " +(this.ec_mothernames[this.ec_contractno]), messageKey: "contract_info", choicesKey: "agree_exit", initialChoicesKey: "2_VIEW_CHART", model: "ITHAcoin", background: "escort_contracts_bkg4.png", overlay : "welcomeCom.png"}, this.ec_contractchoice2);//background :"escort_contracts_bkg2c.png", overlay : "laserShot.png"}, model :"trader"
	}
	else if (missionVariables.ec_numbertargetsystems > 1)
	{
		this.ec_contractno = 0;
		this.ec_updatemissionvariables();
		mission.runScreen({title: "Escort Contract " +(this.ec_contractno+1)+": Trader " +this.ec_mothernames[this.ec_contractno], messageKey: "contract_info", choicesKey: "agree_exit_next_previous", initialChoicesKey: "2_NEXT", model: "ITHAcoin", background: "escort_contracts_bkg4.png", overlay : "welcomeCom.png"}, this.ec_contractchoice4);
	}
	else if (this.ec_leftScreen)
		{player.consoleMessage("Escort Contracts - All Independent Traders have now secured an escort. No contracts currently available.",10);
		delete this.ec_leftScreen;
		player.ship.dockedStation.setInterface("escort_f4contracts",null);//remove interface if contract accepted or no offers
		}
		else {
		player.ship.dockedStation.setInterface("escort_f4contracts",null);//remove interface if contract accepted or no offers
			}
}
// function used if player leaves mission screens to look at charts.
this.ec_leaveScreen = function()
{
	this.ec_updatecontractsTime = clock.minutes + (60 + Math.round(Math.random()*660));
	if (!this.ec_pendingScreenTimer)
	{this.ec_pendingScreenTimer = new Timer(this, this.ec_screenCheck, 1, 3);}
	else {this.ec_pendingScreenTimer.start();}
}

// mission screen choices.

this.ec_contractchoice2 = function(choice)
{
	if (choice === "1_AGREE")
	{
		this.ec_currentcontract = true;
		this.ec_contractexpiretime = clock.minutes + 180;
		this.ec_missionkills = 0;
		this.ec_mothername = missionVariables.ec_mothername;
		this.ec_targetsystem = missionVariables.ec_targetsystem;
		this.ec_contractactualprice = missionVariables.ec_contractactualprice;
		this.ec_killsbonus = missionVariables.ec_killsbonus;
		mission.runScreen({title: "ITHA Escort Contract Agreed", messageKey: "contract_agreed", background :"escort_contracts_bkg3.png"});
		mission.setInstructionsKey ("Contract_Details", "Escort_Contracts");
		this.ec_cleanupmissionVariables();
		delete this.ec_pendingScreenTimer;
		player.ship.dockedStation.setInterface("escort_f4contracts",null); //remove interfaces option after acceptance
	}
	else if (choice === "2_VIEW_CHART")
		{
		mission.runScreen({title: "Escort Contract: Trader " +(this.ec_mothernames[this.ec_contractno]), messageKey: "contract_chart", choicesKey: "chart_agree_exit", initialChoicesKey: "2_RETURN", background: "contracts_chart.png", backgroundSpecial: "SHORT_RANGE_CHART"}, this.ec_contractchoice2);
		}
	else if (choice === "2_RETURN")
		{
		mission.runScreen({title: "Escort Contract: Trader " +(this.ec_mothernames[this.ec_contractno]), messageKey: "contract_info", choicesKey: "agree_exit", initialChoicesKey: "2_VIEW_CHART", background :"escort_contracts_bkg.png"}, this.ec_contractchoice2);
		}
	else if (choice === "3_EXIT_RETURN")
	{this.ec_leaveScreen();}

	
	else {this.ec_cleanupmissionVariables();
		player.ship.dockedStation.setInterface("escort_f4contracts",null); //remove interfaces option after rejection, though these lines never should happen
			}
}
		


this.ec_contractchoice4 = function(choice)
{
	switch (choice)
	{
		case "1_AGREE":
		{
			this.ec_currentcontract = true;
			this.ec_contractexpiretime = clock.minutes + 180;
			this.ec_missionkills = 0;
			this.ec_mothername = missionVariables.ec_mothername;
			this.ec_targetsystem = missionVariables.ec_targetsystem;
			this.ec_contractactualprice = missionVariables.ec_contractactualprice;
			this.ec_killsbonus = missionVariables.ec_killsbonus;
			mission.runScreen({title: "ITHA Escort Contract Agreed", messageKey: "contract_agreed", background :"escort_contracts_bkg3.png"});
			mission.setInstructionsKey ("Contract_Details", "Escort_Contracts");
			this.ec_cleanupmissionVariables();
			delete this.ec_pendingScreenTimer;
			player.ship.dockedStation.setInterface("escort_f4contracts",null);//remove interfaces option after acceptance
		}
	break;
		case "2_NEXT":
		{
			this.ec_contractno++;
			if (this.ec_contractno === missionVariables.ec_numbertargetsystems)
			{this.ec_contractno = 0;}
			this.ec_updatemissionvariables();
			mission.runScreen({title: "Escort Contract " +(this.ec_contractno+1)+": Trader " +this.ec_mothernames[this.ec_contractno], messageKey: "contract_info", choicesKey: "agree_exit_next_previous", initialChoicesKey: "2_NEXT", background: "escort_contracts_bkg.png"}, this.ec_contractchoice4);
		}
	break;
		case "3_PREVIOUS":
		{
			this.ec_contractno--;
			if (this.ec_contractno < 0 )
			{this.ec_contractno = (missionVariables.ec_numbertargetsystems - 1);}
			this.ec_updatemissionvariables();
			mission.runScreen({title: "Escort Contract " +(this.ec_contractno+1)+": Trader " +this.ec_mothernames[this.ec_contractno], messageKey: "contract_info", choicesKey: "agree_exit_next_previous", initialChoicesKey: "3_PREVIOUS", background: "escort_contracts_bkg.png"}, this.ec_contractchoice4);
		}
	break;
			case "2_NEXTCHART":
		{
			this.ec_contractno++;
			if (this.ec_contractno === missionVariables.ec_numbertargetsystems)
			{this.ec_contractno = 0;}
			this.ec_updatemissionvariables();
			mission.runScreen({title: "Escort Contract " +(this.ec_contractno+1)+": Trader " +this.ec_mothernames[this.ec_contractno], messageKey: "contract_chart", choicesKey: "chart_agree_exit_next_previous", initialChoicesKey: "2_NEXTCHART", background: "contracts_chart.png", backgroundSpecial: "SHORT_RANGE_CHART"}, this.ec_contractchoice4);
		}
	break;
		case "3_PREVIOUSCHART":
		{
			this.ec_contractno--;
			if (this.ec_contractno < 0 )
			{this.ec_contractno = (missionVariables.ec_numbertargetsystems - 1);}
			this.ec_updatemissionvariables();
			mission.runScreen({title: "Escort Contract " +(this.ec_contractno+1)+": Trader " +this.ec_mothernames[this.ec_contractno], messageKey: "contract_chart", choicesKey: "chart_agree_exit_next_previous", initialChoicesKey: "3_PREVIOUSCHART", background: "contracts_chart.png", backgroundSpecial: "SHORT_RANGE_CHART"}, this.ec_contractchoice4);
		}
	break;
	    case "4_VIEW_CHART":
		{
		mission.runScreen({title: "Escort Contract " +(this.ec_contractno+1)+": Trader " +this.ec_mothernames[this.ec_contractno], messageKey: "contract_chart", choicesKey: "chart_agree_exit_next_previous", initialChoicesKey: "4_RETURN", background: "contracts_chart.png", backgroundSpecial: "SHORT_RANGE_CHART"}, this.ec_contractchoice4);
		}
	break;
	    case "4_RETURN":
		{
		mission.runScreen({title: "Escort Contract " +(this.ec_contractno+1)+": Trader " +this.ec_mothernames[this.ec_contractno], messageKey: "contract_info", choicesKey: "agree_exit_next_previous", initialChoicesKey: "4_VIEW_CHART", background :"escort_contracts_bkg.png"}, this.ec_contractchoice4);
		}
	break;
	    case "5_EXIT_RETURN":		
		{this.ec_leaveScreen();}	
	break;

	{this.ec_cleanupmissionVariables();
		player.ship.dockedStation.setInterface("escort_f4contracts",null); //remove interfaces option after rejection, though this line never should happen
			}
	}
}
// used to display prompt messages if player has left mission screens.
this.ec_screenCheck = function()
{
 if (!player.ship.docked)
	{
		this.ec_pendingScreenTimer.stop();
		return;
	}
}
	

// returns player to missionscreens having looked at charts.
this.guiScreenChanged = function(to,from)
{
 if (this.ec_pendingScreenTimer)
 {
	  this.ec_pendingScreenTimer.stop();
	  if (clock.minutes > this.ec_updatecontractsTime) // if player has been away from mission screens for some time re-evaluate contract offers.
	  {
	    this.ec_leftScreen = true;
		delete this.ec_pendingScreenTimer;
		this.ec_cleanupmissionVariables();
			player.ship.dockedStation.setInterface("escort_f4contracts",null); //remove interfaces option after timeout
	  }
	  return;
 }
}
// called to create missionVariables for display on the mission screens.
this.ec_updatemissionvariables = function ()
{
	missionVariables.ec_mothername = this.ec_mothernames[this.ec_contractno];
	missionVariables.ec_targetsystem = this.ec_targetsystems[this.ec_contractno];
	missionVariables.ec_contractactualprice = this.ec_contractactualprice[this.ec_contractno];
	missionVariables.ec_targetsystemname = this.ec_targetsystemsnames[this.ec_contractno];
	missionVariables.ec_killsbonus = this.ec_killsbonus[this.ec_contractno];
	missionVariables.ec_targetgovsymbol = String.fromCharCode((this.ec_targetsystemsgovernment[this.ec_contractno]));
	missionVariables.ec_targetecosymbol = String.fromCharCode(23-(this.ec_targetsystemseco[this.ec_contractno]));
	missionVariables.ec_targettech = ((this.ec_targetsystemstech[this.ec_contractno])+1);
	missionVariables.ec_currentsystemname = system.name;
	missionVariables.ec_currentsystemgov = String.fromCharCode((system.government));
	missionVariables.ec_currentsystemtech = system.techLevel+1;
	missionVariables.ec_currentsystemeco = String.fromCharCode(23-(system.economy));
		
	switch (this.ec_targetsystemsgovernment[this.ec_contractno])
	{
	case 0:
	{
		missionVariables.ec_contractdifficultydesc = "very high";
		missionVariables.ec_contractdifficultystars = String.fromCharCode(8,8,8,8,8);
		missionVariables.ec_targetsystemgovernmentname = "an Anarchy";
		break;
	}
	case 1:
	{
		missionVariables.ec_contractdifficultydesc = "high";
		missionVariables.ec_contractdifficultystars = String.fromCharCode(8,8,8,8,24);
		missionVariables.ec_targetsystemgovernmentname = "a Feudal State";
		break;
	}
	case 2:
	{
		missionVariables.ec_contractdifficultydesc = "moderate";
		missionVariables.ec_contractdifficultystars = String.fromCharCode(8,8,8,24,24);
		missionVariables.ec_targetsystemgovernmentname = "a Multi-Government system";
		break;
	}
	case 3:
	{
		missionVariables.ec_contractdifficultydesc = "moderate";
		missionVariables.ec_contractdifficultystars = String.fromCharCode(8,8,8,24,24);
		missionVariables.ec_targetsystemgovernmentname = "a Dictatorship";
		break;
	}
	case 4:
	{
		missionVariables.ec_contractdifficultydesc = "low";
		missionVariables.ec_contractdifficultystars = String.fromCharCode(8,8,24,24,24);
		missionVariables.ec_targetsystemgovernmentname = "a Communist system";
		break;
	}
	case 5:
	{
		missionVariables.ec_contractdifficultydesc = "low";
		missionVariables.ec_contractdifficultystars = String.fromCharCode(8,8,24,24,24);
		missionVariables.ec_targetsystemgovernmentname = "a Confederacy";
		break;
	}
	case 6:
	{
		missionVariables.ec_contractdifficultydesc = "very low";
		missionVariables.ec_contractdifficultystars = String.fromCharCode(8,24,24,24,24);
		missionVariables.ec_targetsystemgovernmentname = "a Democracy";
		break;
	}
	}	
	
	
}
// clean up mission variables after contract mission screens.
this.ec_cleanupmissionVariables = function()
{
    delete missionVariables.ec_contractdifficultydesc;
    delete missionVariables.ec_contractdifficultystars;
	delete missionVariables.ec_numbertargetsystems;
	delete missionVariables.ec_targetsystem;
	delete missionVariables.ec_targetsystemgovernmentname;
	delete missionVariables.ec_targetsystemname;
	delete missionVariables.ec_contractactualprice;
	delete missionVariables.ec_killsbonus;
	delete missionVariables.ec_mothername;
	delete missionVariables.ec_targetgovsymbol;
	delete missionVariables.ec_currentsystemeco;
	delete missionVariables.ec_targetecosymbol;
	delete missionVariables.ec_currentsystemname;
	delete missionVariables.ec_currentsystemgov;
	delete missionVariables.ec_currentsystemtech;
	delete missionVariables.ec_currentsystemeco;
	delete missionVariables.ec_targettech;
}


// event handler function to spawn the mother on player launch if she does not exist but there is a current contract.
this.shipWillLaunchFromStation = function()
{
	if (this.ec_currentcontract && this.ec_currentcontract !== "success")
	{
		if (system.countShipsWithRole("ec_mother") === 0 && clock.minutes < this.ec_contractexpiretime)
		{	
			this.mother = system.addShips("ec_mother", 1, system.mainStation.position.subtract(system.mainStation.vectorForward.multiply(14000)),4000)[0];
		}
		else // if more than 3 game hours passed since agreeing contract - fail contract.
		{
		player.consoleMessage("Escort Contract - You failed to launch within the allocated time window. Your mother has already departed. Contract Terminated.",10);
		delete this.ec_currentcontract;
		mission.setInstructionsKey (null, "Escort_Contracts");
		this.ec_escortrep--;
		if (this.ec_escortrep < -10){this.ec_escortrep = -10;} 
		}
	}
}
// event handler driven function to fail the contract if the player exits witchspace into a system where the mother is not present. Also controls gradual reduction of positive or negative escort reputation in between contracts.
this.shipExitedWitchspace = function()
{
	if (system.countShipsWithRole("ec_mother") === 0 && this.ec_currentcontract) // wrong system
	{
	    if (this.ec_currentcontract === "success") {delete this.ec_currentcontract;} //case where mother safely docked, but player saved at OXP station and never collected reward.
		else {this.ec_failedtofollowmother();}
	}
	if (!this.ec_currentcontract && Math.random() < 0.1) // no contract - random chance of reputation erosion.
	{this.ec_escortrep = Math.round(this.ec_escortrep * 0.8);}
    if (!this.ec_currentcontract && system.countShipsWithRole("ec_mother") !== 0) // if contract has failed, but there is a mother in the system get rid of her.
	{this.mother.remove(true);}	
}
// called from various points within the worldscript if the player has not managed to follow the mother to the target system.
this.ec_failedtofollowmother = function()
{
	delete this.ec_currentcontract;
	mission.setInstructionsKey (null, "Escort_Contracts");
	this.ec_escortrep--;
	if (this.ec_escortrep < -10){this.ec_escortrep = -10;}
	player.consoleMessage("Escort Contract - You have failed to follow your mother-ship to the target system. Contract Terminated.",10);
}
// keeps a record of hostile pirate kills during the course of the contract. Only kills that occur within 2 scanner ranges of the mother count.
this.shipTargetDestroyed = function(target)
{
	if(this.mother && this.mother.isValid && this.ec_currentcontract && player.ship.position.distanceTo(this.mother.position) < (this.mother.scannerRange * 3))
	{
		if(target.bounty > 0 && !target.isRock && !target.isCargo) // only kills that have a bounty and ain't rocks or cargo count!
		{
			this.ec_missionkills++;
			if (!this.mother.alertHostiles && !player.alertHostiles)
			{this.mother.commsMessage("You got the [describe-pirate]. [thanks-for-assist].");}
		}
	}
}
// timer called from mother shipscript on the mother entering witchspace to the target system. Fails the contract if the player fails to follow before the wormhole expires. 
this.ec_motherexitedsystem = function(mothermass)
{
	var expirytime = 50 + (mothermass/4000); // same formula as used by core game code to calculate wormhole expiry.
	this.wormholetimer = new Timer (this, this.ec_checkforfollowedmother, expirytime);
}
// called by timer at wormhole expiry. If player is still in original system contract has failed.
this.ec_checkforfollowedmother = function()
{
	if(this.ec_currentcontract)
	{if (system.countShipsWithRole("ec_mother") === 0) {this.ec_failedtofollowmother();}}
}
// function to stop the Escort License being damaged in combat.
this.equipmentDamaged = function(equipment)
{if(equipment === "EQ_ESCORTCONTRACTS"){player.ship.setEquipmentStatus(equipment,"EQUIPMENT_OK");}}